import { ZodSchema, z } from 'zod';
import { a as Metric } from './types-BtMyV38I.cjs';
export { E as EvaluationResult, M as MetricResult, T as TestInfo } from './types-BtMyV38I.cjs';
import { i as ToolsInput, j as Agent$1, k as AgentConfig, e as MastraStorage$1, l as MastraMemory$1, m as ToolExecutionContext, n as Tool$1, o as ToolAction, p as Step, W as Workflow$1, q as WorkflowOptions } from './base-ibU_552L.cjs';
export { ay as ActionContext, a5 as AnyToolAction, ax as BaseCondition, B as BaseStructuredOutputType, Y as Config, u as CoreAssistantMessage, s as CoreMessage, t as CoreSystemMessage, a4 as CoreTool, w as CoreToolMessage, v as CoreUserMessage, N as DefaultLLMStreamObjectOptions, K as DefaultLLMStreamOptions, J as DefaultLLMTextObjectOptions, I as DefaultLLMTextOptions, af as DependenciesType, aM as DependencyCheckOutput, y as EmbedManyResult, x as EmbedResult, E as EvalRow, aT as ExtractSchemaFromStep, aW as ExtractSchemaType, aU as ExtractStepResult, G as GenerateReturn, aj as InferZodType, U as LLMInnerStreamOptions, X as LLMStreamObjectOptions, R as LLMStreamOptions, Q as LLMTextObjectOptions, P as LLMTextOptions, L as LanguageModel, a as Mastra, _ as MemoryConfig, a1 as MemoryProcessor, a0 as MemoryProcessorOpts, Z as MessageResponse, g as MessageType, O as OutputType, aX as PathsToStringProps, aJ as ResolverFunctionInput, aK as ResolverFunctionOutput, av as RetryConfig, $ as SharedMemoryConfig, ar as StepAction, aB as StepCondition, aC as StepConfig, aA as StepDef, aq as StepExecutionContext, au as StepGraph, aS as StepId, aV as StepInputType, at as StepNode, aN as StepResolverOutput, aD as StepResult, as as StepVariableType, aE as StepsRecord, S as StorageColumn, h as StorageGetMessagesArg, f as StorageThreadType, H as StreamReturn, F as StructuredOutput, D as StructuredOutputArrayItem, z as StructuredOutputType, aL as SubscriberFunctionOutput, ab as TagMaskOptions, a6 as ToolActionWithDeps, aw as VariableReference, a3 as VercelTool, az as WhenConditionReturnValue, aP as WorkflowActionParams, aQ as WorkflowActions, aO as WorkflowActors, aG as WorkflowContext, aI as WorkflowEvent, aH as WorkflowLogMessage, aZ as WorkflowResumeResult, r as WorkflowRow, aF as WorkflowRunResult, aY as WorkflowRunState, aR as WorkflowState, ao as checkEvalStorageFields, ah as createDependenciesFrom, ag as createEmptyDependencies, an as createMastraProxy, a_ as createStep, a2 as createTool, aa as deepMerge, a7 as delay, ap as ensureAllMessagesAreCoreMessages, al as ensureToolProperties, ae as isVercelTool, ak as isZodType, a8 as jsonSchemaPropertiesToTSTypes, a9 as jsonSchemaToModel, am as makeCoreTool, ac as maskStreamTags, ad as resolveSerializedZodOutput, ai as validateDependencies } from './base-ibU_552L.cjs';
import { M as MastraBase$1 } from './base-CvQbEqGB.cjs';
export { O as OtelConfig, S as SamplingStrategy, T as Telemetry } from './base-CvQbEqGB.cjs';
import { R as RegisteredLogger, a as LogLevel, T as TransportMap, L as Logger } from './index-CquI0inB.cjs';
export { B as BaseLogMessage, b as LoggerTransport, M as MultiLogger, c as combineLoggers, n as noopLogger } from './index-CquI0inB.cjs';
import { MastraDeployer as MastraDeployer$1 } from './deployer/index.cjs';
export { evaluate } from './eval/index.cjs';
import { Integration as Integration$1, OpenAPIToolset as OpenAPIToolset$1 } from './integration/index.cjs';
export { CohereRelevanceScorer, MastraAgentRelevanceScorer, RelevanceScoreProvider, createSimilarityPrompt } from './relevance/index.cjs';
export { InstrumentClass, OTLPStorageExporter, hasActiveTelemetry, withSpan } from './telemetry/index.cjs';
import { MastraTTS as MastraTTS$1, TTSConfig } from './tts/index.cjs';
import { MastraVector as MastraVector$1 } from './vector/index.cjs';
export { CreateIndexArgs, CreateIndexParams, IndexStats, ParamsToArgs, QueryResult, QueryVectorArgs, QueryVectorParams, UpsertVectorArgs, UpsertVectorParams } from './vector/index.cjs';
export { agentToStep, getActivePathsAndStatus, getResultActivePaths, getStepResult, getSuspendedPaths, isAgent, isErrorEvent, isFinalState, isLimboState, isTransitionEvent, isVariableReference, isWorkflow, mergeChildValue, recursivelyCheckForFinalState, resolveVariables, updateStepInHierarchy, workflowToStep } from './workflows/index.cjs';
export { AvailableHooks, executeHook, registerHook } from './hooks/index.cjs';
export { Message as AiMessageType } from 'ai';
import 'sift';
import 'json-schema';
import '@opentelemetry/api';
import 'xstate';
import 'node:events';
import 'hono';
import 'hono-openapi';
import '@opentelemetry/sdk-trace-base';
import 'stream';
import 'pino';
import './bundler/index.cjs';
import '@opentelemetry/core';
import './vector/filter/index.cjs';

declare class Agent<TAgentId extends string = string, TSchemaDeps extends ZodSchema | undefined = undefined, TTools extends ToolsInput<TSchemaDeps> = ToolsInput<TSchemaDeps>, TMetrics extends Record<string, Metric> = Record<string, Metric>> extends Agent$1<TAgentId, TSchemaDeps, TTools, TMetrics> {
    constructor(config: AgentConfig<TAgentId, TSchemaDeps, TTools, TMetrics>);
}

declare class MastraBase extends MastraBase$1 {
    constructor(args: {
        component?: RegisteredLogger;
        name?: string;
    });
}

declare abstract class MastraDeployer extends MastraDeployer$1 {
    constructor(args: {
        name: string;
        mastraDir: string;
        outputDirectory: string;
    });
}

declare abstract class MastraStorage extends MastraStorage$1 {
    constructor({ name }: {
        name: string;
    });
}

declare class Integration<ToolsParams = void, ApiClient = void> extends Integration$1<ToolsParams, ApiClient> {
    constructor();
}

declare abstract class OpenAPIToolset extends OpenAPIToolset$1 {
    constructor();
}

declare function createLogger(options: {
    name?: string;
    level?: LogLevel;
    transports?: TransportMap;
}): Logger;

declare abstract class MastraMemory extends MastraMemory$1 {
    constructor(_arg?: any);
}

declare class Tool<TSchemaIn extends z.ZodSchema | undefined = undefined, TSchemaOut extends z.ZodSchema | undefined = undefined, TSchemaDeps extends z.ZodSchema | undefined = undefined, TContext extends ToolExecutionContext<TSchemaIn, TSchemaDeps> = ToolExecutionContext<TSchemaIn, TSchemaDeps>> extends Tool$1<TSchemaIn, TSchemaOut, TSchemaDeps, TContext> {
    constructor(opts: ToolAction<TSchemaIn, TSchemaOut, TSchemaDeps, TContext>);
}

declare abstract class MastraTTS extends MastraTTS$1 {
    constructor(args: TTSConfig);
}

declare abstract class MastraVector extends MastraVector$1 {
    constructor();
}

declare class Workflow<TSteps extends Step<any, any, any>[] = any, TTriggerSchema extends z.ZodObject<any> = any> extends Workflow$1<TSteps, string, TTriggerSchema> {
    constructor(args: WorkflowOptions<string, TSteps, TTriggerSchema>);
}

export { Agent, Integration, LogLevel, Logger, MastraBase, MastraDeployer, MastraMemory, MastraStorage, MastraTTS, MastraVector, Metric, OpenAPIToolset, RegisteredLogger, Step, TTSConfig, Tool, ToolAction, ToolExecutionContext, TransportMap, Workflow, WorkflowOptions, createLogger };
